/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.254 Revision 1.332
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.254 2006/10/18 21:35:19 drizzt Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.332 2010/02/17 02:22:43 reavertm Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 33}
24 34
25# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
27# don't beep. 37# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 42ebeep() {
30 local n 43 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 46 echo -ne "\a"
36 sleep 1 49 sleep 1
37 done 50 done
38 fi 51 fi
39} 52}
40 53
41# This function generate linker scripts in /usr/lib for dynamic 54else
42# libs in /lib. This is to fix linking problems when you have 55
43# the .so in /lib, and the .a in /usr/lib. What happens is that 56ebeep() {
44# in some cases when linking dynamic, the .a in /usr/lib is used 57 eqawarn "QA Notice: ebeep is not defined in EAPI=3, please file a bug at http://bugs.gentoo.org"
45# instead of the .so in /lib due to gcc/libtool tweaking ld's 58}
46# library search path. This cause many builds to fail. 59
47# See bug #4411 for more info. 60epause() {
48# 61 eqawarn "QA Notice: epause is not defined in EAPI=3, please file a bug at http://bugs.gentoo.org"
49# To use, simply call: 62}
50# 63
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 if [[ $(type -t _tc_gen_usr_ldscript) == "function" ]] ; then
61 _tc_gen_usr_ldscript "$@"
62 return $?
63 fi 64fi
64 65
65 ewarn "QA Notice: Please upgrade your ebuild to use toolchain-funcs" 66# @FUNCTION: ecvs_clean
66 ewarn "QA Notice: rather than gen_usr_ldscript() from eutils" 67# @USAGE: [list of dirs]
68# @DESCRIPTION:
69# Remove CVS directories recursiveley. Useful when a source tarball contains
70# internal CVS directories. Defaults to $PWD.
71ecvs_clean() {
72 [[ -z $* ]] && set -- .
73 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
74 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
75}
67 76
68 local lib libdir=$(get_libdir) 77# @FUNCTION: esvn_clean
69 # Just make sure it exists 78# @USAGE: [list of dirs]
70 dodir /usr/${libdir} 79# @DESCRIPTION:
80# Remove .svn directories recursiveley. Useful when a source tarball contains
81# internal Subversion directories. Defaults to $PWD.
82esvn_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
85}
71 86
72 for lib in "${@}" ; do 87# @FUNCTION: eshopts_push
73 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 88# @USAGE: [options to `set` or `shopt`]
74 /* GNU ld script 89# @DESCRIPTION:
75 Since Gentoo has critical dynamic libraries 90# Often times code will want to enable a shell option to change code behavior.
76 in /lib, and the static versions in /usr/lib, 91# Since changing shell options can easily break other pieces of code (which
77 we need to have a "fake" dynamic lib in /usr/lib, 92# assume the default state), eshopts_push is used to (1) push the current shell
78 otherwise we run into linking problems. 93# options onto a stack and (2) pass the specified arguments to set.
79 94#
80 See bug http://bugs.gentoo.org/4411 for more info. 95# If the first argument is '-s' or '-u', we assume you want to call `shopt`
81 */ 96# rather than `set` as there are some options only available via that.
82 GROUP ( /${libdir}/${lib} ) 97#
83 END_LDSCRIPT 98# A common example is to disable shell globbing so that special meaning/care
84 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 99# may be used with variables/arguments to custom functions. That would be:
100# @CODE
101# eshopts_push -o noglob
102# for x in ${foo} ; do
103# if ...some check... ; then
104# eshopts_pop
105# return 0
106# fi
85 done 107# done
108# eshopts_pop
109# @CODE
110eshopts_push() {
111 # have to assume __ESHOPTS_SAVE__ isn't screwed with
112 # as a `declare -a` here will reset its value
113 local i=${#__ESHOPTS_SAVE__[@]}
114 if [[ $1 == -[su] ]] ; then
115 __ESHOPTS_SAVE__[$i]=$(shopt -p)
116 [[ $# -eq 0 ]] && return 0
117 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
118 else
119 __ESHOPTS_SAVE__[$i]=$-
120 [[ $# -eq 0 ]] && return 0
121 set "$@" || die "eshopts_push: bad options to set: $*"
122 fi
86} 123}
87 124
125# @FUNCTION: eshopts_pop
126# @USAGE:
127# @DESCRIPTION:
128# Restore the shell options to the state saved with the corresponding
129# eshopts_push call. See that function for more details.
130eshopts_pop() {
131 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
132 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
133 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
134 local s=${__ESHOPTS_SAVE__[$i]}
135 unset __ESHOPTS_SAVE__[$i]
136 if [[ ${s} == "shopt -"* ]] ; then
137 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
138 else
139 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
140 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
141 fi
142}
88 143
89# Default directory where patches are located 144# @VARIABLE: EPATCH_SOURCE
145# @DESCRIPTION:
146# Default directory to search for patches.
90EPATCH_SOURCE="${WORKDIR}/patch" 147EPATCH_SOURCE="${WORKDIR}/patch"
91# Default extension for patches 148# @VARIABLE: EPATCH_SUFFIX
149# @DESCRIPTION:
150# Default extension for patches (do not prefix the period yourself).
92EPATCH_SUFFIX="patch.bz2" 151EPATCH_SUFFIX="patch.bz2"
152# @VARIABLE: EPATCH_OPTS
153# @DESCRIPTION:
93# Default options for patch 154# Default options for patch:
155# @CODE
94# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 156# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
95# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 157# --no-backup-if-mismatch - do not leave .orig files behind
96# Set -E to automatically remove empty files. 158# -E - automatically remove empty files
159# @CODE
97EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 160EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
161# @VARIABLE: EPATCH_EXCLUDE
162# @DESCRIPTION:
98# List of patches not to apply. Not this is only file names, 163# List of patches not to apply. Note this is only file names,
99# and not the full path .. 164# and not the full path. Globs accepted.
100EPATCH_EXCLUDE="" 165EPATCH_EXCLUDE=""
166# @VARIABLE: EPATCH_SINGLE_MSG
167# @DESCRIPTION:
101# Change the printed message for a single patch. 168# Change the printed message for a single patch.
102EPATCH_SINGLE_MSG="" 169EPATCH_SINGLE_MSG=""
170# @VARIABLE: EPATCH_MULTI_MSG
171# @DESCRIPTION:
103# Change the printed message for multiple patches. 172# Change the printed message for multiple patches.
104EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 173EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
105# Force applying bulk patches even if not following the style: 174# @VARIABLE: EPATCH_FORCE
106# 175# @DESCRIPTION:
107# ??_${ARCH}_foo.${EPATCH_SUFFIX} 176# Only require patches to match EPATCH_SUFFIX rather than the extended
108# 177# arch naming style.
109EPATCH_FORCE="no" 178EPATCH_FORCE="no"
110 179
111# This function is for bulk patching, or in theory for just one 180# @FUNCTION: epatch
112# or two patches. 181# @USAGE: [patches] [dirs of patches]
182# @DESCRIPTION:
183# epatch is designed to greatly simplify the application of patches. It can
184# process patch files directly, or directories of patches. The patches may be
185# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
186# the -p option as epatch will automatically attempt -p0 to -p5 until things
187# apply successfully.
113# 188#
114# It should work with .bz2, .gz, .zip and plain text patches. 189# If you do not specify any options, then epatch will default to the directory
115# Currently all patches should be the same format. 190# specified by EPATCH_SOURCE.
116# 191#
117# You do not have to specify '-p' option to patch, as it will 192# When processing directories, epatch will apply all patches that match:
118# try with -p0 to -p5 until it succeed, or fail at -p5. 193# @CODE
119# 194# ${EPATCH_FORCE} == "yes"
120# Above EPATCH_* variables can be used to control various defaults,
121# bug they should be left as is to ensure an ebuild can rely on
122# them for.
123#
124# Patches are applied in current directory.
125#
126# Bulk Patches should preferibly have the form of:
127#
128# ??_${ARCH}_foo.${EPATCH_SUFFIX} 195# ??_${ARCH}_foo.${EPATCH_SUFFIX}
196# else
197# *.${EPATCH_SUFFIX}
198# @CODE
199# The leading ?? are typically numbers used to force consistent patch ordering.
200# The arch field is used to apply patches only for the host architecture with
201# the special value of "all" means apply for everyone. Note that using values
202# other than "all" is highly discouraged -- you should apply patches all the
203# time and let architecture details be detected at configure/compile time.
129# 204#
130# For example: 205# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
206# for patches to apply.
131# 207#
132# 01_all_misc-fix.patch.bz2 208# Refer to the other EPATCH_xxx variables for more customization of behavior.
133# 02_sparc_another-fix.patch.bz2
134#
135# This ensures that there are a set order, and you can have ARCH
136# specific patches.
137#
138# If you however give an argument to epatch(), it will treat it as a
139# single patch that need to be applied if its a file. If on the other
140# hand its a directory, it will set EPATCH_SOURCE to this.
141#
142# <azarah@gentoo.org> (10 Nov 2002)
143#
144epatch() { 209epatch() {
145 _epatch_draw_line() { 210 _epatch_draw_line() {
211 # create a line of same length as input string
146 [[ -z $1 ]] && set "$(printf "%65s" '')" 212 [[ -z $1 ]] && set "$(printf "%65s" '')"
147 echo "${1//?/=}" 213 echo "${1//?/=}"
148 } 214 }
149 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
150 local PIPE_CMD=""
151 local STDERR_TARGET="${T}/$$.out"
152 local PATCH_TARGET="${T}/$$.patch"
153 local PATCH_SUFFIX=""
154 local SINGLE_PATCH="no"
155 local x=""
156 215
157 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 216 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
158 217
159 if [ "$#" -gt 1 ] 218 # Let the rest of the code process one user arg at a time --
160 then 219 # each arg may expand into multiple patches, and each arg may
220 # need to start off with the default global EPATCH_xxx values
221 if [[ $# -gt 1 ]] ; then
161 local m="" 222 local m
162 for m in "$@" ; do 223 for m in "$@" ; do
163 epatch "${m}" 224 epatch "${m}"
164 done 225 done
165 return 0 226 return 0
166 fi 227 fi
167 228
168 if [ -n "$1" -a -f "$1" ] 229 local SINGLE_PATCH="no"
169 then 230 # no args means process ${EPATCH_SOURCE}
231 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
232
233 if [[ -f $1 ]] ; then
170 SINGLE_PATCH="yes" 234 SINGLE_PATCH="yes"
171 235 set -- "$1"
172 local EPATCH_SOURCE="$1" 236 # Use the suffix from the single patch (localize it); the code
237 # below will find the suffix for us
173 local EPATCH_SUFFIX="${1##*\.}" 238 local EPATCH_SUFFIX=$1
174 239
175 elif [ -n "$1" -a -d "$1" ] 240 elif [[ -d $1 ]] ; then
176 then 241 # Some people like to make dirs of patches w/out suffixes (vim)
177 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 242 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
178 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 243
244 else
245 # sanity check ... if it isn't a dir or file, wtf man ?
246 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
247 echo
248 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
249 eerror
250 eerror " ${EPATCH_SOURCE}"
251 eerror " ( ${EPATCH_SOURCE##*/} )"
252 echo
253 die "Cannot find \$EPATCH_SOURCE!"
254 fi
255
256 local PIPE_CMD
257 case ${EPATCH_SUFFIX##*\.} in
258 xz) PIPE_CMD="xz -dc" ;;
259 lzma) PIPE_CMD="lzma -dc" ;;
260 bz2) PIPE_CMD="bzip2 -dc" ;;
261 gz|Z|z) PIPE_CMD="gzip -dc" ;;
262 ZIP|zip) PIPE_CMD="unzip -p" ;;
263 *) ;;
264 esac
265
266 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
267
268 local x
269 for x in "$@" ; do
270 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
271 # didn't match anything, ignore continue on
272 [[ ! -f ${x} ]] && continue
273
274 local patchname=${x##*/}
275
276 # Apply single patches, or forced sets of patches, or
277 # patches with ARCH dependant names.
278 # ???_arch_foo.patch
279 # Else, skip this input altogether
280 local a=${patchname#*_} # strip the ???_
281 a=${a%%_*} # strip the _foo.patch
282 if ! [[ ${SINGLE_PATCH} == "yes" || \
283 ${EPATCH_FORCE} == "yes" || \
284 ${a} == all || \
285 ${a} == ${ARCH} ]]
179 then 286 then
180 local EPATCH_SOURCE="$1/*" 287 continue
288 fi
289
290 # Let people filter things dynamically
291 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
292 # let people use globs in the exclude
293 eshopts_push -o noglob
294
295 local ex
296 for ex in ${EPATCH_EXCLUDE} ; do
297 if [[ ${patchname} == ${ex} ]] ; then
298 eshopts_pop
299 continue 2
300 fi
301 done
302
303 eshopts_pop
304 fi
305
306 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
307 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
308 einfo "${EPATCH_SINGLE_MSG}"
309 else
310 einfo "Applying ${patchname} ..."
311 fi
181 else 312 else
182 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 313 einfo " ${patchname} ..."
183 fi 314 fi
184 else 315
185 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 316 # most of the time, there will only be one run per unique name,
186 then 317 # but if there are more, make sure we get unique log filenames
187 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 318 local STDERR_TARGET="${T}/${patchname}.out"
188 then 319 if [[ -e ${STDERR_TARGET} ]] ; then
189 EPATCH_SOURCE="$1" 320 STDERR_TARGET="${T}/${patchname}-$$.out"
321 fi
322
323 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
324
325 # Decompress the patch if need be
326 local count=0
327 local PATCH_TARGET
328 if [[ -n ${PIPE_CMD} ]] ; then
329 PATCH_TARGET="${T}/$$.patch"
330 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
331
332 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
333 echo
334 eerror "Could not extract patch!"
335 #die "Could not extract patch!"
336 count=5
337 break
190 fi 338 fi
339 else
340 PATCH_TARGET=${x}
341 fi
191 342
343 # Check for absolute paths in patches. If sandbox is disabled,
344 # people could (accidently) patch files in the root filesystem.
345 # Or trigger other unpleasantries #237667. So disallow -p0 on
346 # such patches.
347 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
348 if [[ -n ${abs_paths} ]] ; then
349 count=1
350 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
351 fi
352
353 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
354 while [[ ${count} -lt 5 ]] ; do
355 # Generate some useful debug info ...
356 (
357 _epatch_draw_line "***** ${patchname} *****"
192 echo 358 echo
193 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 359 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
360 echo
361 _epatch_draw_line "***** ${patchname} *****"
362 ) >> "${STDERR_TARGET}"
363
364 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
365 (
366 _epatch_draw_line "***** ${patchname} *****"
367 echo
368 echo "ACTUALLY APPLYING ${patchname} ..."
369 echo
370 _epatch_draw_line "***** ${patchname} *****"
371 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
372 ) >> "${STDERR_TARGET}"
373
374 if [ $? -ne 0 ] ; then
375 echo
376 eerror "A dry-run of patch command succeeded, but actually"
377 eerror "applying the patch failed!"
378 #die "Real world sux compared to the dreamworld!"
379 count=5
380 fi
381 break
382 fi
383
384 : $(( count++ ))
385 done
386
387 # if we had to decompress the patch, delete the temp one
388 if [[ -n ${PIPE_CMD} ]] ; then
389 rm -f "${PATCH_TARGET}"
390 fi
391
392 if [[ ${count} -ge 5 ]] ; then
393 echo
394 eerror "Failed Patch: ${patchname} !"
395 eerror " ( ${PATCH_TARGET} )"
194 eerror 396 eerror
195 eerror " ${EPATCH_SOURCE}" 397 eerror "Include in your bugreport the contents of:"
196 eerror " ( ${EPATCH_SOURCE##*/} )" 398 eerror
399 eerror " ${STDERR_TARGET}"
197 echo 400 echo
198 die "Cannot find \$EPATCH_SOURCE!"
199 fi
200
201 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
202 fi
203
204 case ${EPATCH_SUFFIX##*\.} in
205 bz2)
206 PIPE_CMD="bzip2 -dc"
207 PATCH_SUFFIX="bz2"
208 ;;
209 gz|Z|z)
210 PIPE_CMD="gzip -dc"
211 PATCH_SUFFIX="gz"
212 ;;
213 ZIP|zip)
214 PIPE_CMD="unzip -p"
215 PATCH_SUFFIX="zip"
216 ;;
217 *)
218 PIPE_CMD="cat"
219 PATCH_SUFFIX="patch"
220 ;;
221 esac
222
223 if [ "${SINGLE_PATCH}" = "no" ]
224 then
225 einfo "${EPATCH_MULTI_MSG}"
226 fi
227 for x in ${EPATCH_SOURCE}
228 do
229 # New ARCH dependant patch naming scheme ...
230 #
231 # ???_arch_foo.patch
232 #
233 if [ -f ${x} ] && \
234 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
235 [ "${EPATCH_FORCE}" = "yes" ])
236 then
237 local count=0
238 local popts="${EPATCH_OPTS}"
239 local patchname=${x##*/}
240
241 if [ -n "${EPATCH_EXCLUDE}" ]
242 then
243 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
244 then
245 continue
246 fi
247 fi
248
249 if [ "${SINGLE_PATCH}" = "yes" ]
250 then
251 if [ -n "${EPATCH_SINGLE_MSG}" ]
252 then
253 einfo "${EPATCH_SINGLE_MSG}"
254 else
255 einfo "Applying ${patchname} ..."
256 fi
257 else
258 einfo " ${patchname} ..."
259 fi
260
261 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263
264 # Allow for prefix to differ ... im lazy, so shoot me :/
265 while [ "${count}" -lt 5 ]
266 do
267 # Generate some useful debug info ...
268 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270
271 if [ "${PATCH_SUFFIX}" != "patch" ]
272 then
273 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 else
276 PATCH_TARGET="${x}"
277 fi
278
279 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281
282 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 if [ "${PATCH_SUFFIX}" != "patch" ]
286 then
287 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
288 then
289 echo
290 eerror "Could not extract patch!"
291 #die "Could not extract patch!"
292 count=5
293 break
294 fi
295 fi
296
297 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
298 then
299 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
301 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
303 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
304
305 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
306 _epatch_assert
307
308 if [ "$?" -ne 0 ]
309 then
310 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
311 echo
312 eerror "A dry-run of patch command succeeded, but actually"
313 eerror "applying the patch failed!"
314 #die "Real world sux compared to the dreamworld!"
315 count=5
316 fi
317
318 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319
320 break
321 fi
322
323 count=$((count + 1))
324 done
325
326 if [ "${PATCH_SUFFIX}" != "patch" ]
327 then
328 rm -f ${PATCH_TARGET}
329 fi
330
331 if [ "${count}" -eq 5 ]
332 then
333 echo
334 eerror "Failed Patch: ${patchname} !"
335 eerror " ( ${PATCH_TARGET} )"
336 eerror
337 eerror "Include in your bugreport the contents of:"
338 eerror
339 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
340 echo
341 die "Failed Patch: ${patchname}!" 401 die "Failed Patch: ${patchname}!"
342 fi 402 fi
343 403
344 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 404 # if everything worked, delete the patch log
345 405 rm -f "${STDERR_TARGET}"
346 eend 0 406 eend 0
347 fi
348 done 407 done
349 if [ "${SINGLE_PATCH}" = "no" ] 408
350 then 409 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
351 einfo "Done with patching" 410 : # everything worked
411}
412epatch_user() {
413 [[ $# -ne 0 ]] && die "epatch_user takes no options"
414
415 # don't clobber any EPATCH vars that the parent might want
416 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
417 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
418 EPATCH_SOURCE=${base}/${CTARGET}/${check}
419 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
420 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
421 if [[ -d ${EPATCH_SOURCE} ]] ; then
422 EPATCH_SOURCE=${EPATCH_SOURCE} \
423 EPATCH_SUFFIX="patch" \
424 EPATCH_FORCE="yes" \
425 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
426 epatch
427 break
352 fi 428 fi
429 done
353} 430}
354 431
432# @FUNCTION: emktemp
433# @USAGE: [temp dir]
434# @DESCRIPTION:
355# Cheap replacement for when debianutils (and thus mktemp) 435# Cheap replacement for when debianutils (and thus mktemp)
356# does not exist on the users system 436# does not exist on the users system.
357# vapier@gentoo.org
358#
359# Takes just 1 optional parameter (the directory to create tmpfile in)
360emktemp() { 437emktemp() {
361 local exe="touch" 438 local exe="touch"
362 [[ $1 == -d ]] && exe="mkdir" && shift 439 [[ $1 == -d ]] && exe="mkdir" && shift
363 local topdir=$1 440 local topdir=$1
364 441
366 [[ -z ${T} ]] \ 443 [[ -z ${T} ]] \
367 && topdir="/tmp" \ 444 && topdir="/tmp" \
368 || topdir=${T} 445 || topdir=${T}
369 fi 446 fi
370 447
371 if [[ -z $(type -p mktemp) ]] ; then 448 if ! type -P mktemp > /dev/null ; then
449 # system lacks `mktemp` so we have to fake it
372 local tmp=/ 450 local tmp=/
373 while [[ -e ${tmp} ]] ; do 451 while [[ -e ${tmp} ]] ; do
374 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 452 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
375 done 453 done
376 ${exe} "${tmp}" || ${exe} -p "${tmp}" 454 ${exe} "${tmp}" || ${exe} -p "${tmp}"
377 echo "${tmp}" 455 echo "${tmp}"
378 else 456 else
457 # the args here will give slightly wierd names on BSD,
458 # but should produce a usable file on all userlands
379 if [[ ${exe} == "touch" ]] ; then 459 if [[ ${exe} == "touch" ]] ; then
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -p "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -t tmp 460 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
383 else 461 else
384 [[ ${USERLAND} == "GNU" ]] \
385 && mktemp -d "${topdir}" \
386 || TMPDIR="${topdir}" mktemp -dt tmp 462 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
387 fi
388 fi 463 fi
464 fi
389} 465}
390 466
467# @FUNCTION: egetent
468# @USAGE: <database> <key>
469# @MAINTAINER:
470# base-system@gentoo.org (Linux)
471# Joe Jezak <josejx@gmail.com> (OS X)
472# usata@gentoo.org (OS X)
473# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
474# @DESCRIPTION:
391# Small wrapper for getent (Linux), nidump (Mac OS X), 475# Small wrapper for getent (Linux),
476# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
392# and pw (FreeBSD) used in enewuser()/enewgroup() 477# and pw (FreeBSD) used in enewuser()/enewgroup()
393# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
394# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
395#
396# egetent(database, key)
397egetent() { 478egetent() {
398 case ${CHOST} in 479 case ${CHOST} in
399 *-darwin*) 480 *-darwin[678])
400 case "$2" in 481 case "$2" in
401 *[!0-9]*) # Non numeric 482 *[!0-9]*) # Non numeric
402 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 483 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
403 ;; 484 ;;
404 *) # Numeric 485 *) # Numeric
405 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 486 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
487 ;;
488 esac
489 ;;
490 *-darwin*)
491 local mytype=$1
492 [[ "passwd" == $mytype ]] && mytype="Users"
493 [[ "group" == $mytype ]] && mytype="Groups"
494 case "$2" in
495 *[!0-9]*) # Non numeric
496 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
497 ;;
498 *) # Numeric
499 local mykey="UniqueID"
500 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
501 dscl . -search /$mytype $mykey $2 2>/dev/null
406 ;; 502 ;;
407 esac 503 esac
408 ;; 504 ;;
409 *-freebsd*|*-dragonfly*) 505 *-freebsd*|*-dragonfly*)
410 local opts action="user" 506 local opts action="user"
425 getent "$1" "$2" 521 getent "$1" "$2"
426 ;; 522 ;;
427 esac 523 esac
428} 524}
429 525
430# Simplify/standardize adding users to the system 526# @FUNCTION: enewuser
431# vapier@gentoo.org 527# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
432# 528# @DESCRIPTION:
433# enewuser(username, uid, shell, homedir, groups, extra options) 529# Same as enewgroup, you are not required to understand how to properly add
434# 530# a user to the system. The only required parameter is the username.
435# Default values if you do not specify any: 531# Default uid is (pass -1 for this) next available, default shell is
436# username: REQUIRED ! 532# /bin/false, default homedir is /dev/null, there are no default groups,
437# uid: next available (see useradd(8)) 533# and default params sets the comment as 'added by portage for ${PN}'.
438# note: pass -1 to get default behavior
439# shell: /bin/false
440# homedir: /dev/null
441# groups: none
442# extra: comment of 'added by portage for ${PN}'
443enewuser() { 534enewuser() {
444 case ${EBUILD_PHASE} in 535 case ${EBUILD_PHASE} in
445 unpack|compile|test|install) 536 unpack|compile|test|install)
446 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 537 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
447 eerror "Package fails at QA and at life. Please file a bug." 538 eerror "Package fails at QA and at life. Please file a bug."
454 eerror "No username specified !" 545 eerror "No username specified !"
455 die "Cannot call enewuser without a username" 546 die "Cannot call enewuser without a username"
456 fi 547 fi
457 548
458 # lets see if the username already exists 549 # lets see if the username already exists
459 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 550 if [[ -n $(egetent passwd "${euser}") ]] ; then
460 return 0 551 return 0
461 fi 552 fi
462 einfo "Adding user '${euser}' to your system ..." 553 einfo "Adding user '${euser}' to your system ..."
463 554
464 # options to pass to useradd 555 # options to pass to useradd
465 local opts= 556 local opts=
466 557
467 # handle uid 558 # handle uid
468 local euid=$1; shift 559 local euid=$1; shift
469 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 560 if [[ -n ${euid} && ${euid} != -1 ]] ; then
470 if [[ ${euid} -gt 0 ]] ; then 561 if [[ ${euid} -gt 0 ]] ; then
471 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 562 if [[ -n $(egetent passwd ${euid}) ]] ; then
472 euid="next" 563 euid="next"
473 fi 564 fi
474 else 565 else
475 eerror "Userid given but is not greater than 0 !" 566 eerror "Userid given but is not greater than 0 !"
476 die "${euid} is not a valid UID" 567 die "${euid} is not a valid UID"
477 fi 568 fi
478 else 569 else
479 euid="next" 570 euid="next"
480 fi 571 fi
481 if [[ ${euid} == "next" ]] ; then 572 if [[ ${euid} == "next" ]] ; then
482 for euid in $(seq 101 999) ; do 573 for ((euid = 101; euid <= 999; euid++)); do
483 [[ -z $(egetent passwd ${euid}) ]] && break 574 [[ -z $(egetent passwd ${euid}) ]] && break
484 done 575 done
485 fi 576 fi
486 opts="${opts} -u ${euid}" 577 opts="${opts} -u ${euid}"
487 einfo " - Userid: ${euid}" 578 einfo " - Userid: ${euid}"
615 fi 706 fi
616 ;; 707 ;;
617 708
618 *) 709 *)
619 if [[ -z $@ ]] ; then 710 if [[ -z $@ ]] ; then
620 useradd ${opts} ${euser} \ 711 useradd ${opts} \
621 -c "added by portage for ${PN}" \ 712 -c "added by portage for ${PN}" \
713 ${euser} \
622 || die "enewuser failed" 714 || die "enewuser failed"
623 else 715 else
624 einfo " - Extra: $@" 716 einfo " - Extra: $@"
625 useradd ${opts} ${euser} "$@" \ 717 useradd ${opts} "$@" \
718 ${euser} \
626 || die "enewuser failed" 719 || die "enewuser failed"
627 fi 720 fi
628 ;; 721 ;;
629 esac 722 esac
630 723
636 fi 729 fi
637 730
638 export SANDBOX_ON=${oldsandbox} 731 export SANDBOX_ON=${oldsandbox}
639} 732}
640 733
641# Simplify/standardize adding groups to the system 734# @FUNCTION: enewgroup
642# vapier@gentoo.org 735# @USAGE: <group> [gid]
643# 736# @DESCRIPTION:
644# enewgroup(group, gid) 737# This function does not require you to understand how to properly add a
645# 738# group to the system. Just give it a group name to add and enewgroup will
646# Default values if you do not specify any: 739# do the rest. You may specify the gid for the group or allow the group to
647# groupname: REQUIRED ! 740# allocate the next available one.
648# gid: next available (see groupadd(8))
649# extra: none
650enewgroup() { 741enewgroup() {
651 case ${EBUILD_PHASE} in 742 case ${EBUILD_PHASE} in
652 unpack|compile|test|install) 743 unpack|compile|test|install)
653 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 744 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
654 eerror "Package fails at QA and at life. Please file a bug." 745 eerror "Package fails at QA and at life. Please file a bug."
662 eerror "No group specified !" 753 eerror "No group specified !"
663 die "Cannot call enewgroup without a group" 754 die "Cannot call enewgroup without a group"
664 fi 755 fi
665 756
666 # see if group already exists 757 # see if group already exists
667 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 758 if [[ -n $(egetent group "${egroup}") ]]; then
668 then
669 return 0 759 return 0
670 fi 760 fi
671 einfo "Adding group '${egroup}' to your system ..." 761 einfo "Adding group '${egroup}' to your system ..."
672 762
673 # options to pass to useradd 763 # options to pass to useradd
716 fi 806 fi
717 807
718 # If we need the next available 808 # If we need the next available
719 case ${egid} in 809 case ${egid} in
720 *[!0-9]*) # Non numeric 810 *[!0-9]*) # Non numeric
721 for egid in $(seq 101 999); do 811 for ((egid = 101; egid <= 999; egid++)); do
722 [ -z "`egetent group ${egid}`" ] && break 812 [[ -z $(egetent group ${egid}) ]] && break
723 done 813 done
724 esac 814 esac
725 dscl . create /groups/${egroup} gid ${egid} 815 dscl . create /groups/${egroup} gid ${egid}
726 dscl . create /groups/${egroup} passwd '*' 816 dscl . create /groups/${egroup} passwd '*'
727 ;; 817 ;;
728 818
729 *-freebsd*|*-dragonfly*) 819 *-freebsd*|*-dragonfly*)
730 case ${egid} in 820 case ${egid} in
731 *[!0-9]*) # Non numeric 821 *[!0-9]*) # Non numeric
732 for egid in $(seq 101 999); do 822 for ((egid = 101; egid <= 999; egid++)); do
733 [ -z "`egetent group ${egid}`" ] && break 823 [[ -z $(egetent group ${egid}) ]] && break
734 done 824 done
735 esac 825 esac
736 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 826 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
737 ;; 827 ;;
738 828
739 *-netbsd*) 829 *-netbsd*)
740 case ${egid} in 830 case ${egid} in
741 *[!0-9]*) # Non numeric 831 *[!0-9]*) # Non numeric
742 for egid in $(seq 101 999); do 832 for ((egid = 101; egid <= 999; egid++)); do
743 [ -z "`egetent group ${egid}`" ] && break 833 [[ -z $(egetent group ${egid}) ]] && break
744 done 834 done
745 esac 835 esac
746 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 836 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
747 ;; 837 ;;
748 838
751 ;; 841 ;;
752 esac 842 esac
753 export SANDBOX_ON="${oldsandbox}" 843 export SANDBOX_ON="${oldsandbox}"
754} 844}
755 845
756# Simple script to replace 'dos2unix' binaries 846# @FUNCTION: edos2unix
757# vapier@gentoo.org 847# @USAGE: <file> [more files ...]
758# 848# @DESCRIPTION:
759# edos2unix(file, <more files> ...) 849# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
850# to remove all of these text utilities from DEPEND variables because this
851# is a script based solution. Just give it a list of files to convert and
852# they will all be changed from the DOS CRLF format to the UNIX LF format.
760edos2unix() { 853edos2unix() {
761 for f in "$@" 854 echo "$@" | xargs sed -i 's/\r$//'
762 do
763 cp "${f}" ${T}/edos2unix
764 sed 's/\r$//' ${T}/edos2unix > "${f}"
765 done
766} 855}
767
768
769##############################################################
770# START: Handle .desktop files and menu entries #
771# maybe this should be separated into a new eclass some time #
772# lanius@gentoo.org #
773##############################################################
774 856
775# Make a desktop file ! 857# Make a desktop file !
776# Great for making those icons in kde/gnome startmenu ! 858# Great for making those icons in kde/gnome startmenu !
777# Amaze your friends ! Get the women ! Join today ! 859# Amaze your friends ! Get the women ! Join today !
778# 860#
779# make_desktop_entry(<command>, [name], [icon], [type], [path]) 861# make_desktop_entry(<command>, [name], [icon], [type], [path])
780# 862#
781# binary: what command does the app run with ? 863# binary: what command does the app run with ?
782# name: the name that will show up in the menu 864# name: the name that will show up in the menu
783# icon: give your little like a pretty little icon ... 865# icon: give your little like a pretty little icon ...
784# this can be relative (to /usr/share/pixmaps) or 866# this can be relative (to /usr/share/pixmaps) or
785# a full path to an icon 867# a full path to an icon
786# type: what kind of application is this ? for categories: 868# type: what kind of application is this ? for categories:
787# http://www.freedesktop.org/Standards/desktop-entry-spec 869# http://standards.freedesktop.org/menu-spec/latest/apa.html
788# path: if your app needs to startup in a specific dir 870# path: if your app needs to startup in a specific dir
789make_desktop_entry() { 871make_desktop_entry() {
790 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 872 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
791 873
792 local exec=${1} 874 local exec=${1}
793 local name=${2:-${PN}} 875 local name=${2:-${PN}}
794 local icon=${3:-${PN}.png} 876 local icon=${3:-${PN}}
795 local type=${4} 877 local type=${4}
796 local path=${5} 878 local path=${5}
797 879
798 if [[ -z ${type} ]] ; then 880 if [[ -z ${type} ]] ; then
799 local catmaj=${CATEGORY%%-*} 881 local catmaj=${CATEGORY%%-*}
800 local catmin=${CATEGORY##*-} 882 local catmin=${CATEGORY##*-}
801 case ${catmaj} in 883 case ${catmaj} in
802 app) 884 app)
803 case ${catmin} in 885 case ${catmin} in
886 accessibility) type=Accessibility;;
804 admin) type=System;; 887 admin) type=System;;
888 antivirus) type=System;;
889 arch) type=Archiving;;
890 backup) type=Archiving;;
805 cdr) type=DiscBurning;; 891 cdr) type=DiscBurning;;
806 dicts) type=Dictionary;; 892 dicts) type=Dictionary;;
893 doc) type=Documentation;;
807 editors) type=TextEditor;; 894 editors) type=TextEditor;;
808 emacs) type=TextEditor;; 895 emacs) type=TextEditor;;
809 emulation) type=Emulator;; 896 emulation) type=Emulator;;
810 laptop) type=HardwareSettings;; 897 laptop) type=HardwareSettings;;
811 office) type=Office;; 898 office) type=Office;;
899 pda) type=PDA;;
812 vim) type=TextEditor;; 900 vim) type=TextEditor;;
813 xemacs) type=TextEditor;; 901 xemacs) type=TextEditor;;
814 *) type=;; 902 *) type=;;
815 esac 903 esac
816 ;; 904 ;;
817 905
818 dev) 906 dev)
819 type="Development" 907 type="Development"
820 ;; 908 ;;
821 909
822 games) 910 games)
823 case ${catmin} in 911 case ${catmin} in
824 action) type=ActionGame;; 912 action|fps) type=ActionGame;;
825 arcade) type=ArcadeGame;; 913 arcade) type=ArcadeGame;;
826 board) type=BoardGame;; 914 board) type=BoardGame;;
827 kids) type=KidsGame;;
828 emulation) type=Emulator;; 915 emulation) type=Emulator;;
916 kids) type=KidsGame;;
829 puzzle) type=LogicGame;; 917 puzzle) type=LogicGame;;
830 rpg) type=RolePlaying;;
831 roguelike) type=RolePlaying;; 918 roguelike) type=RolePlaying;;
919 rpg) type=RolePlaying;;
832 simulation) type=Simulation;; 920 simulation) type=Simulation;;
833 sports) type=SportsGame;; 921 sports) type=SportsGame;;
834 strategy) type=StrategyGame;; 922 strategy) type=StrategyGame;;
835 *) type=;; 923 *) type=;;
836 esac 924 esac
837 type="Game;${type}" 925 type="Game;${type}"
926 ;;
927
928 gnome)
929 type="Gnome;GTK"
930 ;;
931
932 kde)
933 type="KDE;Qt"
838 ;; 934 ;;
839 935
840 mail) 936 mail)
841 type="Network;Email" 937 type="Network;Email"
842 ;; 938 ;;
844 media) 940 media)
845 case ${catmin} in 941 case ${catmin} in
846 gfx) type=Graphics;; 942 gfx) type=Graphics;;
847 radio) type=Tuner;; 943 radio) type=Tuner;;
848 sound) type=Audio;; 944 sound) type=Audio;;
849 tv) type=TV;; 945 tv) type=TV;;
850 video) type=Video;; 946 video) type=Video;;
851 *) type=;; 947 *) type=;;
852 esac 948 esac
853 type="AudioVideo;${type}" 949 type="AudioVideo;${type}"
854 ;; 950 ;;
855 951
856 net) 952 net)
857 case ${catmin} in 953 case ${catmin} in
858 dialup) type=Dialup;; 954 dialup) type=Dialup;;
859 ftp) type=FileTransfer;; 955 ftp) type=FileTransfer;;
860 im) type=InstantMessaging;; 956 im) type=InstantMessaging;;
861 irc) type=IRCClient;; 957 irc) type=IRCClient;;
862 mail) type=Email;; 958 mail) type=Email;;
863 news) type=News;; 959 news) type=News;;
864 nntp) type=News;; 960 nntp) type=News;;
865 p2p) type=FileTransfer;; 961 p2p) type=FileTransfer;;
866 *) type=;; 962 *) type=;;
867 esac 963 esac
868 type="Network;${type}" 964 type="Network;${type}"
869 ;; 965 ;;
870 966
871 sci) 967 sci)
872 case ${catmin} in 968 case ${catmin} in
873 astro*) type=Astronomy;; 969 astro*) type=Astronomy;;
874 bio*) type=Biology;; 970 bio*) type=Biology;;
875 calc*) type=Calculator;; 971 calc*) type=Calculator;;
876 chem*) type=Chemistry;; 972 chem*) type=Chemistry;;
973 elec*) type=Electronics;;
877 geo*) type=Geology;; 974 geo*) type=Geology;;
878 math*) type=Math;; 975 math*) type=Math;;
976 physics) type=Physics;;
977 visual*) type=DataVisualization;;
879 *) type=;; 978 *) type=;;
880 esac 979 esac
881 type="Science;${type}" 980 type="Science;${type}"
882 ;; 981 ;;
883 982
983 sys)
984 type="System"
985 ;;
986
884 www) 987 www)
885 case ${catmin} in 988 case ${catmin} in
886 client) type=WebBrowser;; 989 client) type=WebBrowser;;
887 *) type=;; 990 *) type=;;
888 esac 991 esac
889 type="Network" 992 type="Network"
890 ;; 993 ;;
891 994
892 *) 995 *)
897 if [ "${SLOT}" == "0" ] ; then 1000 if [ "${SLOT}" == "0" ] ; then
898 local desktop_name="${PN}" 1001 local desktop_name="${PN}"
899 else 1002 else
900 local desktop_name="${PN}-${SLOT}" 1003 local desktop_name="${PN}-${SLOT}"
901 fi 1004 fi
902 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1005 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
903# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1006 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
904 1007
1008 cat <<-EOF > "${desktop}"
905echo "[Desktop Entry] 1009 [Desktop Entry]
906Encoding=UTF-8
907Version=0.9.2
908Name=${name} 1010 Name=${name}
909Type=Application 1011 Type=Application
910Comment=${DESCRIPTION} 1012 Comment=${DESCRIPTION}
911Exec=${exec} 1013 Exec=${exec}
912TryExec=${exec%% *} 1014 TryExec=${exec%% *}
913Path=${path}
914Icon=${icon} 1015 Icon=${icon}
915Categories=Application;${type};" > "${desktop}" 1016 Categories=${type};
1017 EOF
1018
1019 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}"
916 1020
917 ( 1021 (
918 # wrap the env here so that the 'insinto' call 1022 # wrap the env here so that the 'insinto' call
919 # doesn't corrupt the env of the caller 1023 # doesn't corrupt the env of the caller
920 insinto /usr/share/applications 1024 insinto /usr/share/applications
921 doins "${desktop}" 1025 doins "${desktop}"
922 ) 1026 )
923} 1027}
924 1028
925# Make a GDM/KDM Session file 1029# @FUNCTION: validate_desktop_entries
926# 1030# @USAGE: [directories]
927# make_session_desktop(<title>, <command>) 1031# @MAINTAINER:
928# title: File to execute to start the Window Manager 1032# Carsten Lohrke <carlo@gentoo.org>
929# command: Name of the Window Manager 1033# @DESCRIPTION:
1034# Validate desktop entries using desktop-file-utils
1035validate_desktop_entries() {
1036 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1037 einfo "Checking desktop entry validity"
1038 local directories=""
1039 for d in /usr/share/applications $@ ; do
1040 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1041 done
1042 if [[ -n ${directories} ]] ; then
1043 for FILE in $(find ${directories} -name "*\.desktop" \
1044 -not -path '*.hidden*' | sort -u 2>/dev/null)
1045 do
1046 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1047 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1048 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1049 done
1050 fi
1051 echo ""
1052 else
1053 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1054 fi
1055}
930 1056
1057# @FUNCTION: make_session_desktop
1058# @USAGE: <title> <command> [command args...]
1059# @DESCRIPTION:
1060# Make a GDM/KDM Session file. The title is the file to execute to start the
1061# Window Manager. The command is the name of the Window Manager.
1062#
1063# You can set the name of the file via the ${wm} variable.
931make_session_desktop() { 1064make_session_desktop() {
932 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1065 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
933 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1066 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
934 1067
935 local title=$1 1068 local title=$1
936 local command=$2 1069 local command=$2
937 local desktop=${T}/${wm}.desktop 1070 local desktop=${T}/${wm:-${PN}}.desktop
1071 shift 2
938 1072
1073 cat <<-EOF > "${desktop}"
939echo "[Desktop Entry] 1074 [Desktop Entry]
940Encoding=UTF-8
941Name=${title} 1075 Name=${title}
942Comment=This session logs you into ${title} 1076 Comment=This session logs you into ${title}
943Exec=${command} 1077 Exec=${command} $*
944TryExec=${command} 1078 TryExec=${command}
945Type=Application" > "${desktop}" 1079 Type=XSession
1080 EOF
946 1081
1082 (
1083 # wrap the env here so that the 'insinto' call
1084 # doesn't corrupt the env of the caller
947 insinto /usr/share/xsessions 1085 insinto /usr/share/xsessions
948 doins "${desktop}" 1086 doins "${desktop}"
1087 )
949} 1088}
950 1089
1090# @FUNCTION: domenu
1091# @USAGE: <menus>
1092# @DESCRIPTION:
1093# Install the list of .desktop menu files into the appropriate directory
1094# (/usr/share/applications).
951domenu() { 1095domenu() {
1096 (
1097 # wrap the env here so that the 'insinto' call
1098 # doesn't corrupt the env of the caller
952 local i j 1099 local i j ret=0
953 insinto /usr/share/applications 1100 insinto /usr/share/applications
954 for i in "$@" ; do 1101 for i in "$@" ; do
955 if [[ -f ${i} ]] ; then 1102 if [[ -f ${i} ]] ; then
956 doins "${i}" 1103 doins "${i}"
1104 ((ret+=$?))
957 elif [[ -d ${i} ]] ; then 1105 elif [[ -d ${i} ]] ; then
958 for j in "${i}"/*.desktop ; do 1106 for j in "${i}"/*.desktop ; do
959 doins "${j}" 1107 doins "${j}"
1108 ((ret+=$?))
960 done 1109 done
1110 else
1111 ((++ret))
961 fi 1112 fi
962 done 1113 done
1114 exit ${ret}
1115 )
963} 1116}
1117
1118# @FUNCTION: newmenu
1119# @USAGE: <menu> <newname>
1120# @DESCRIPTION:
1121# Like all other new* functions, install the specified menu as newname.
964newmenu() { 1122newmenu() {
1123 (
1124 # wrap the env here so that the 'insinto' call
1125 # doesn't corrupt the env of the caller
965 insinto /usr/share/applications 1126 insinto /usr/share/applications
966 newins "$1" "$2" 1127 newins "$@"
1128 )
967} 1129}
968 1130
1131# @FUNCTION: doicon
1132# @USAGE: <list of icons>
1133# @DESCRIPTION:
1134# Install the list of icons into the icon directory (/usr/share/pixmaps).
1135# This is useful in conjunction with creating desktop/menu files.
969doicon() { 1136doicon() {
1137 (
1138 # wrap the env here so that the 'insinto' call
1139 # doesn't corrupt the env of the caller
970 local i j 1140 local i j ret
971 insinto /usr/share/pixmaps 1141 insinto /usr/share/pixmaps
972 for i in "$@" ; do 1142 for i in "$@" ; do
973 if [[ -f ${i} ]] ; then 1143 if [[ -f ${i} ]] ; then
974 doins "${i}" 1144 doins "${i}"
1145 ((ret+=$?))
975 elif [[ -d ${i} ]] ; then 1146 elif [[ -d ${i} ]] ; then
976 for j in "${i}"/*.png ; do 1147 for j in "${i}"/*.png ; do
977 doins "${j}" 1148 doins "${j}"
1149 ((ret+=$?))
978 done 1150 done
1151 else
1152 ((++ret))
979 fi 1153 fi
980 done 1154 done
1155 exit ${ret}
1156 )
981} 1157}
1158
1159# @FUNCTION: newicon
1160# @USAGE: <icon> <newname>
1161# @DESCRIPTION:
1162# Like all other new* functions, install the specified icon as newname.
982newicon() { 1163newicon() {
1164 (
1165 # wrap the env here so that the 'insinto' call
1166 # doesn't corrupt the env of the caller
983 insinto /usr/share/pixmaps 1167 insinto /usr/share/pixmaps
984 newins "$1" "$2" 1168 newins "$@"
1169 )
985} 1170}
986
987##############################################################
988# END: Handle .desktop files and menu entries #
989##############################################################
990
991 1171
992# for internal use only (unpack_pdv and unpack_makeself) 1172# for internal use only (unpack_pdv and unpack_makeself)
993find_unpackable_file() { 1173find_unpackable_file() {
994 local src=$1 1174 local src=$1
995 if [[ -z ${src} ]] ; then 1175 if [[ -z ${src} ]] ; then
1005 fi 1185 fi
1006 [[ ! -e ${src} ]] && return 1 1186 [[ ! -e ${src} ]] && return 1
1007 echo "${src}" 1187 echo "${src}"
1008} 1188}
1009 1189
1190# @FUNCTION: unpack_pdv
1191# @USAGE: <file to unpack> <size of off_t>
1192# @DESCRIPTION:
1010# Unpack those pesky pdv generated files ... 1193# Unpack those pesky pdv generated files ...
1011# They're self-unpacking programs with the binary package stuffed in 1194# They're self-unpacking programs with the binary package stuffed in
1012# the middle of the archive. Valve seems to use it a lot ... too bad 1195# the middle of the archive. Valve seems to use it a lot ... too bad
1013# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1196# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1014# 1197#
1015# Usage: unpack_pdv [file to unpack] [size of off_t]
1016# - you have to specify the off_t size ... i have no idea how to extract that 1198# You have to specify the off_t size ... I have no idea how to extract that
1017# information out of the binary executable myself. basically you pass in 1199# information out of the binary executable myself. Basically you pass in
1018# the size of the off_t type (in bytes) on the machine that built the pdv 1200# the size of the off_t type (in bytes) on the machine that built the pdv
1201# archive.
1202#
1019# archive. one way to determine this is by running the following commands: 1203# One way to determine this is by running the following commands:
1204#
1205# @CODE
1020# strings <pdv archive> | grep lseek 1206# strings <pdv archive> | grep lseek
1021# strace -elseek <pdv archive> 1207# strace -elseek <pdv archive>
1208# @CODE
1209#
1022# basically look for the first lseek command (we do the strings/grep because 1210# Basically look for the first lseek command (we do the strings/grep because
1023# sometimes the function call is _llseek or something) and steal the 2nd 1211# sometimes the function call is _llseek or something) and steal the 2nd
1024# parameter. here is an example: 1212# parameter. Here is an example:
1213#
1214# @CODE
1025# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1215# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1026# lseek 1216# lseek
1027# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1217# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1028# lseek(3, -4, SEEK_END) = 2981250 1218# lseek(3, -4, SEEK_END) = 2981250
1219# @CODE
1220#
1029# thus we would pass in the value of '4' as the second parameter. 1221# Thus we would pass in the value of '4' as the second parameter.
1030unpack_pdv() { 1222unpack_pdv() {
1031 local src=$(find_unpackable_file $1) 1223 local src=$(find_unpackable_file "$1")
1032 local sizeoff_t=$2 1224 local sizeoff_t=$2
1033 1225
1034 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1226 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1035 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1227 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1036 1228
1037 local shrtsrc=$(basename "${src}") 1229 local shrtsrc=$(basename "${src}")
1038 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1230 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1039 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1231 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1040 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1232 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1041 1233
1042 # grab metadata for debug reasons 1234 # grab metadata for debug reasons
1043 local metafile="$(emktemp)" 1235 local metafile=$(emktemp)
1044 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1236 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1045 1237
1046 # rip out the final file name from the metadata 1238 # rip out the final file name from the metadata
1047 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1239 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1048 datafile="`basename ${datafile}`" 1240 datafile=$(basename "${datafile}")
1049 1241
1050 # now lets uncompress/untar the file if need be 1242 # now lets uncompress/untar the file if need be
1051 local tmpfile="$(emktemp)" 1243 local tmpfile=$(emktemp)
1052 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1244 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1053 1245
1054 local iscompressed="`file -b ${tmpfile}`" 1246 local iscompressed=$(file -b "${tmpfile}")
1055 if [ "${iscompressed:0:8}" == "compress" ] ; then 1247 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1056 iscompressed=1 1248 iscompressed=1
1057 mv ${tmpfile}{,.Z} 1249 mv ${tmpfile}{,.Z}
1058 gunzip ${tmpfile} 1250 gunzip ${tmpfile}
1059 else 1251 else
1060 iscompressed=0 1252 iscompressed=0
1061 fi 1253 fi
1062 local istar="`file -b ${tmpfile}`" 1254 local istar=$(file -b "${tmpfile}")
1063 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1255 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1064 istar=1 1256 istar=1
1065 else 1257 else
1066 istar=0 1258 istar=0
1067 fi 1259 fi
1068 1260
1096 true 1288 true
1097 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1289 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1098 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1290 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1099} 1291}
1100 1292
1293# @FUNCTION: unpack_makeself
1294# @USAGE: [file to unpack] [offset] [tail|dd]
1295# @DESCRIPTION:
1101# Unpack those pesky makeself generated files ... 1296# Unpack those pesky makeself generated files ...
1102# They're shell scripts with the binary package tagged onto 1297# They're shell scripts with the binary package tagged onto
1103# the end of the archive. Loki utilized the format as does 1298# the end of the archive. Loki utilized the format as does
1104# many other game companies. 1299# many other game companies.
1105# 1300#
1106# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1301# If the file is not specified, then ${A} is used. If the
1107# - If the file is not specified then unpack will utilize ${A}.
1108# - If the offset is not specified then we will attempt to extract 1302# offset is not specified then we will attempt to extract
1109# the proper offset from the script itself. 1303# the proper offset from the script itself.
1110unpack_makeself() { 1304unpack_makeself() {
1111 local src_input=${1:-${A}} 1305 local src_input=${1:-${A}}
1112 local src=$(find_unpackable_file "${src_input}") 1306 local src=$(find_unpackable_file "${src_input}")
1113 local skip=$2 1307 local skip=$2
1114 local exe=$3 1308 local exe=$3
1160 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1354 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1161 *) die "makeself cant handle exe '${exe}'" 1355 *) die "makeself cant handle exe '${exe}'"
1162 esac 1356 esac
1163 1357
1164 # lets grab the first few bytes of the file to figure out what kind of archive it is 1358 # lets grab the first few bytes of the file to figure out what kind of archive it is
1165 local tmpfile="$(emktemp)" 1359 local tmpfile=$(emktemp)
1166 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1360 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1167 local filetype="$(file -b "${tmpfile}")" 1361 local filetype=$(file -b "${tmpfile}")
1168 case ${filetype} in 1362 case ${filetype} in
1169 *tar\ archive) 1363 *tar\ archive*)
1170 eval ${exe} | tar --no-same-owner -xf - 1364 eval ${exe} | tar --no-same-owner -xf -
1171 ;; 1365 ;;
1172 bzip2*) 1366 bzip2*)
1173 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1367 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1174 ;; 1368 ;;
1184 ;; 1378 ;;
1185 esac 1379 esac
1186 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1380 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1187} 1381}
1188 1382
1383# @FUNCTION: check_license
1384# @USAGE: [license]
1385# @DESCRIPTION:
1189# Display a license for user to accept. 1386# Display a license for user to accept. If no license is
1190#
1191# Usage: check_license [license]
1192# - If the file is not specified then ${LICENSE} is used. 1387# specified, then ${LICENSE} is used.
1193check_license() { 1388check_license() {
1194 local lic=$1 1389 local lic=$1
1195 if [ -z "${lic}" ] ; then 1390 if [ -z "${lic}" ] ; then
1196 lic="${PORTDIR}/licenses/${LICENSE}" 1391 lic="${PORTDIR}/licenses/${LICENSE}"
1197 else 1392 else
1201 lic="${PWD}/${lic}" 1396 lic="${PWD}/${lic}"
1202 elif [ -e "${lic}" ] ; then 1397 elif [ -e "${lic}" ] ; then
1203 lic="${lic}" 1398 lic="${lic}"
1204 fi 1399 fi
1205 fi 1400 fi
1206 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1207 local l="`basename ${lic}`" 1401 local l="`basename ${lic}`"
1208 1402
1209 # here is where we check for the licenses the user already 1403 # here is where we check for the licenses the user already
1210 # accepted ... if we don't find a match, we make the user accept 1404 # accepted ... if we don't find a match, we make the user accept
1211 local shopts=$-
1212 local alic 1405 local alic
1213 set -o noglob #so that bash doesn't expand "*" 1406 eshopts_push -o noglob # so that bash doesn't expand "*"
1214 for alic in ${ACCEPT_LICENSE} ; do 1407 for alic in ${ACCEPT_LICENSE} ; do
1215 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1408 if [[ ${alic} == ${l} ]]; then
1216 set +o noglob; set -${shopts} #reset old shell opts 1409 eshopts_pop
1217 return 0 1410 return 0
1218 fi 1411 fi
1219 done 1412 done
1220 set +o noglob; set -$shopts #reset old shell opts 1413 eshopts_pop
1414 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1221 1415
1222 local licmsg="$(emktemp)" 1416 local licmsg=$(emktemp)
1223 cat << EOF > ${licmsg} 1417 cat <<-EOF > ${licmsg}
1224********************************************************** 1418 **********************************************************
1225The following license outlines the terms of use of this 1419 The following license outlines the terms of use of this
1226package. You MUST accept this license for installation to 1420 package. You MUST accept this license for installation to
1227continue. When you are done viewing, hit 'q'. If you 1421 continue. When you are done viewing, hit 'q'. If you
1228CTRL+C out of this, the install will not run! 1422 CTRL+C out of this, the install will not run!
1229********************************************************** 1423 **********************************************************
1230 1424
1231EOF 1425 EOF
1232 cat ${lic} >> ${licmsg} 1426 cat ${lic} >> ${licmsg}
1233 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1427 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1234 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1428 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1235 read alic 1429 read alic
1236 case ${alic} in 1430 case ${alic} in
1243 die "Failed to accept license" 1437 die "Failed to accept license"
1244 ;; 1438 ;;
1245 esac 1439 esac
1246} 1440}
1247 1441
1442# @FUNCTION: cdrom_get_cds
1443# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1444# @DESCRIPTION:
1248# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1445# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1249# the whole 'non-interactive' policy, but damnit I want CD support ! 1446# the whole 'non-interactive' policy, but damnit I want CD support !
1250# 1447#
1251# with these cdrom functions we handle all the user interaction and 1448# With these cdrom functions we handle all the user interaction and
1252# standardize everything. all you have to do is call cdrom_get_cds() 1449# standardize everything. All you have to do is call cdrom_get_cds()
1253# and when the function returns, you can assume that the cd has been 1450# and when the function returns, you can assume that the cd has been
1254# found at CDROM_ROOT. 1451# found at CDROM_ROOT.
1255# 1452#
1453# The function will attempt to locate a cd based upon a file that is on
1454# the cd. The more files you give this function, the more cds
1455# the cdrom functions will handle.
1456#
1256# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1457# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1257# etc... if you want to give the cds better names, then just export 1458# etc... If you want to give the cds better names, then just export
1258# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1459# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1259# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1460# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1260# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1461# also use the CDROM_NAME_SET bash array.
1261# CDROM_NAME_2="data cd"
1262# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1263# 1462#
1264# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1463# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1265#
1266# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1267# - this will attempt to locate a cd based upon a file that is on
1268# the cd ... the more files you give this function, the more cds
1269# the cdrom functions will handle
1270cdrom_get_cds() { 1464cdrom_get_cds() {
1271 # first we figure out how many cds we're dealing with by 1465 # first we figure out how many cds we're dealing with by
1272 # the # of files they gave us 1466 # the # of files they gave us
1273 local cdcnt=0 1467 local cdcnt=0
1274 local f= 1468 local f=
1360 export CDROM_SET="" 1554 export CDROM_SET=""
1361 export CDROM_CURRENT_CD=0 1555 export CDROM_CURRENT_CD=0
1362 cdrom_load_next_cd 1556 cdrom_load_next_cd
1363} 1557}
1364 1558
1365# this is only used when you need access to more than one cd. 1559# @FUNCTION: cdrom_load_next_cd
1366# when you have finished using the first cd, just call this function. 1560# @DESCRIPTION:
1367# when it returns, CDROM_ROOT will be pointing to the second cd. 1561# Some packages are so big they come on multiple CDs. When you're done reading
1368# remember, you can only go forward in the cd chain, you can't go back. 1562# files off a CD and want access to the next one, just call this function.
1563# Again, all the messy details of user interaction are taken care of for you.
1564# Once this returns, just read the variable CDROM_ROOT for the location of the
1565# mounted CD. Note that you can only go forward in the CD list, so make sure
1566# you only call this function when you're done using the current CD.
1369cdrom_load_next_cd() { 1567cdrom_load_next_cd() {
1370 local var 1568 local var
1371 ((++CDROM_CURRENT_CD)) 1569 ((++CDROM_CURRENT_CD))
1372 1570
1373 unset CDROM_ROOT 1571 unset CDROM_ROOT
1390# displayed and we'll hang out here until: 1588# displayed and we'll hang out here until:
1391# (1) the file is found on a mounted cdrom 1589# (1) the file is found on a mounted cdrom
1392# (2) the user hits CTRL+C 1590# (2) the user hits CTRL+C
1393_cdrom_locate_file_on_cd() { 1591_cdrom_locate_file_on_cd() {
1394 local mline="" 1592 local mline=""
1395 local showedmsg=0 1593 local showedmsg=0 showjolietmsg=0
1396 1594
1397 while [[ -z ${CDROM_ROOT} ]] ; do 1595 while [[ -z ${CDROM_ROOT} ]] ; do
1398 local i=0 1596 local i=0
1399 local -a cdset=(${*//:/ }) 1597 local -a cdset=(${*//:/ })
1400 if [[ -n ${CDROM_SET} ]] ; then 1598 if [[ -n ${CDROM_SET} ]] ; then
1403 1601
1404 while [[ -n ${cdset[${i}]} ]] ; do 1602 while [[ -n ${cdset[${i}]} ]] ; do
1405 local dir=$(dirname ${cdset[${i}]}) 1603 local dir=$(dirname ${cdset[${i}]})
1406 local file=$(basename ${cdset[${i}]}) 1604 local file=$(basename ${cdset[${i}]})
1407 1605
1408 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1606 local point= node= fs= foo=
1607 while read point node fs foo ; do
1608 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1609 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1610 && continue
1611 point=${point//\040/ }
1409 [[ -d ${mline}/${dir} ]] || continue 1612 [[ ! -d ${point}/${dir} ]] && continue
1410 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1613 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1411 export CDROM_ROOT=${mline} 1614 export CDROM_ROOT=${point}
1412 export CDROM_SET=${i} 1615 export CDROM_SET=${i}
1413 export CDROM_MATCH=${cdset[${i}]} 1616 export CDROM_MATCH=${cdset[${i}]}
1414 return 1617 return
1415 fi 1618 done <<< "$(get_mounts)"
1416 done
1417 1619
1418 ((++i)) 1620 ((++i))
1419 done 1621 done
1420 1622
1421 echo 1623 echo
1437 showedmsg=1 1639 showedmsg=1
1438 fi 1640 fi
1439 einfo "Press return to scan for the cd again" 1641 einfo "Press return to scan for the cd again"
1440 einfo "or hit CTRL+C to abort the emerge." 1642 einfo "or hit CTRL+C to abort the emerge."
1441 echo 1643 echo
1644 if [[ ${showjolietmsg} -eq 0 ]] ; then
1645 showjolietmsg=1
1646 else
1442 einfo "If you are having trouble with the detection" 1647 ewarn "If you are having trouble with the detection"
1443 einfo "of your CD, it is possible that you do not have" 1648 ewarn "of your CD, it is possible that you do not have"
1444 einfo "Joliet support enabled in your kernel. Please" 1649 ewarn "Joliet support enabled in your kernel. Please"
1445 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1650 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1651 ebeep 5
1652 fi
1446 read || die "something is screwed with your system" 1653 read || die "something is screwed with your system"
1447 done 1654 done
1448} 1655}
1449 1656
1657# @FUNCTION: strip-linguas
1658# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1659# @DESCRIPTION:
1450# Make sure that LINGUAS only contains languages that 1660# Make sure that LINGUAS only contains languages that
1451# a package can support 1661# a package can support. The first form allows you to
1452# 1662# specify a list of LINGUAS. The -i builds a list of po
1453# usage: strip-linguas <allow LINGUAS> 1663# files found in all the directories and uses the
1454# strip-linguas -i <directories of .po files> 1664# intersection of the lists. The -u builds a list of po
1455# strip-linguas -u <directories of .po files> 1665# files found in all the directories and uses the union
1456# 1666# of the lists.
1457# The first form allows you to specify a list of LINGUAS.
1458# The -i builds a list of po files found in all the
1459# directories and uses the intersection of the lists.
1460# The -u builds a list of po files found in all the
1461# directories and uses the union of the lists.
1462strip-linguas() { 1667strip-linguas() {
1463 local ls newls nols 1668 local ls newls nols
1464 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1669 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1465 local op=$1; shift 1670 local op=$1; shift
1466 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1671 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1467 local d f 1672 local d f
1468 for d in "$@" ; do 1673 for d in "$@" ; do
1469 if [[ ${op} == "-u" ]] ; then 1674 if [[ ${op} == "-u" ]] ; then
1470 newls=${ls} 1675 newls=${ls}
1471 else 1676 else
1472 newls="" 1677 newls=""
1473 fi 1678 fi
1474 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1679 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1475 if [[ ${op} == "-i" ]] ; then 1680 if [[ ${op} == "-i" ]] ; then
1476 hasq ${f} ${ls} && newls="${newls} ${f}" 1681 hasq ${f} ${ls} && newls="${newls} ${f}"
1477 else 1682 else
1478 hasq ${f} ${ls} || newls="${newls} ${f}" 1683 hasq ${f} ${ls} || newls="${newls} ${f}"
1479 fi 1684 fi
1492 else 1697 else
1493 nols="${nols} ${f}" 1698 nols="${nols} ${f}"
1494 fi 1699 fi
1495 done 1700 done
1496 [[ -n ${nols} ]] \ 1701 [[ -n ${nols} ]] \
1497 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1702 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1498 export LINGUAS=${newls:1} 1703 export LINGUAS=${newls:1}
1499} 1704}
1500 1705
1501# moved from kernel.eclass since they are generally useful outside of 1706# @FUNCTION: preserve_old_lib
1502# kernel.eclass -iggy (20041002) 1707# @USAGE: <libs to preserve> [more libs]
1503 1708# @DESCRIPTION:
1504# the following functions are useful in kernel module ebuilds, etc.
1505# for an example see ivtv or drbd ebuilds
1506
1507# set's ARCH to match what the kernel expects
1508set_arch_to_kernel() {
1509 i=10
1510 while ((i--)) ; do
1511 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1512 done
1513 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1514 case ${ARCH} in
1515 x86) export ARCH="i386";;
1516 amd64) export ARCH="x86_64";;
1517 hppa) export ARCH="parisc";;
1518 mips) export ARCH="mips";;
1519 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1520 *) export ARCH="${ARCH}";;
1521 esac
1522}
1523
1524# set's ARCH back to what portage expects
1525set_arch_to_portage() {
1526 i=10
1527 while ((i--)) ; do
1528 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1529 done
1530 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1531}
1532
1533# Jeremy Huddleston <eradicator@gentoo.org>:
1534# preserve_old_lib /path/to/libblah.so.0
1535# preserve_old_lib_notify /path/to/libblah.so.0
1536#
1537# These functions are useful when a lib in your package changes --library. Such 1709# These functions are useful when a lib in your package changes ABI SONAME.
1538# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1710# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1539# would break packages that link against it. Most people get around this 1711# would break packages that link against it. Most people get around this
1540# by using the portage SLOT mechanism, but that is not always a relevant 1712# by using the portage SLOT mechanism, but that is not always a relevant
1541# solution, so instead you can add the following to your ebuilds: 1713# solution, so instead you can call this from pkg_preinst. See also the
1542# 1714# preserve_old_lib_notify function.
1543# src_install() {
1544# ...
1545# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1546# ...
1547# }
1548#
1549# pkg_postinst() {
1550# ...
1551# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1552# ...
1553# }
1554
1555preserve_old_lib() { 1715preserve_old_lib() {
1556 LIB=$1 1716 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1717 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1718 die "Invalid preserve_old_lib() usage"
1719 fi
1720 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1557 1721
1558 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1722 # let portage worry about it
1559 SONAME=`basename ${LIB}` 1723 has preserve-libs ${FEATURES} && return 0
1560 DIRNAME=`dirname ${LIB}`
1561 1724
1562 dodir ${DIRNAME} 1725 local lib dir
1563 cp ${ROOT}${LIB} ${D}${DIRNAME} 1726 for lib in "$@" ; do
1727 [[ -e ${ROOT}/${lib} ]] || continue
1728 dir=${lib%/*}
1729 dodir ${dir} || die "dodir ${dir} failed"
1730 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1564 touch ${D}${LIB} 1731 touch "${D}"/${lib}
1565 fi 1732 done
1566} 1733}
1567 1734
1735# @FUNCTION: preserve_old_lib_notify
1736# @USAGE: <libs to notify> [more libs]
1737# @DESCRIPTION:
1738# Spit helpful messages about the libraries preserved by preserve_old_lib.
1568preserve_old_lib_notify() { 1739preserve_old_lib_notify() {
1569 LIB=$1 1740 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1741 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1742 die "Invalid preserve_old_lib_notify() usage"
1743 fi
1570 1744
1571 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1745 # let portage worry about it
1572 SONAME=`basename ${LIB}` 1746 has preserve-libs ${FEATURES} && return 0
1573 1747
1748 local lib notice=0
1749 for lib in "$@" ; do
1750 [[ -e ${ROOT}/${lib} ]] || continue
1751 if [[ ${notice} -eq 0 ]] ; then
1752 notice=1
1574 ewarn "An old version of an installed library was detected on your system." 1753 ewarn "Old versions of installed libraries were detected on your system."
1575 ewarn "In order to avoid breaking packages that link against it, this older version" 1754 ewarn "In order to avoid breaking packages that depend on these old libs,"
1576 ewarn "is not being removed. In order to make full use of this newer version," 1755 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1577 ewarn "you will need to execute the following command:" 1756 ewarn "in order to remove these old dependencies. If you do not have this"
1757 ewarn "helper program, simply emerge the 'gentoolkit' package."
1758 ewarn
1759 fi
1578 ewarn " revdep-rebuild --library ${SONAME}" 1760 ewarn " # revdep-rebuild --library ${lib##*/}"
1761 done
1762 if [[ ${notice} -eq 1 ]] ; then
1579 ewarn 1763 ewarn
1580 ewarn "After doing that, you can safely remove ${LIB}" 1764 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1581 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1765 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1766 for lib in "$@" ; do
1767 ewarn " # rm '${lib}'"
1768 done
1582 fi 1769 fi
1583} 1770}
1584 1771
1585# Hack for people to figure out if a package was built with 1772# @FUNCTION: built_with_use
1586# certain USE flags 1773# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1774# @DESCRIPTION:
1587# 1775#
1588# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1776# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1589# ex: built_with_use xchat gtk2
1590# 1777#
1591# Flags: -a all USE flags should be utilized 1778# A temporary hack until portage properly supports DEPENDing on USE
1592# -o at least one USE flag should be utilized 1779# flags being enabled in packages. This will check to see if the specified
1593# Note: the default flag is '-a' 1780# DEPEND atom was built with the specified list of USE flags. The
1781# --missing option controls the behavior if called on a package that does
1782# not actually support the defined USE flags (aka listed in IUSE).
1783# The default is to abort (call die). The -a and -o flags control
1784# the requirements of the USE flags. They correspond to "and" and "or"
1785# logic. So the -a flag means all listed USE flags must be enabled
1786# while the -o flag means at least one of the listed IUSE flags must be
1787# enabled. The --hidden option is really for internal use only as it
1788# means the USE flag we're checking is hidden expanded, so it won't be found
1789# in IUSE like normal USE flags.
1790#
1791# Remember that this function isn't terribly intelligent so order of optional
1792# flags matter.
1594built_with_use() { 1793built_with_use() {
1794 local hidden="no"
1795 if [[ $1 == "--hidden" ]] ; then
1796 hidden="yes"
1797 shift
1798 fi
1799
1800 local missing_action="die"
1801 if [[ $1 == "--missing" ]] ; then
1802 missing_action=$2
1803 shift ; shift
1804 case ${missing_action} in
1805 true|false|die) ;;
1806 *) die "unknown action '${missing_action}'";;
1807 esac
1808 fi
1809
1595 local opt=$1 1810 local opt=$1
1596 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1811 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1597 1812
1598 local PKG=$(best_version $1) 1813 local PKG=$(best_version $1)
1599 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package" 1814 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1600 shift 1815 shift
1601 1816
1602 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1817 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1603 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE 1818 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1604 1819
1605 # if the USE file doesnt exist, assume the $PKG is either 1820 # if the IUSE file doesn't exist, the read will error out, we need to handle
1606 # injected or package.provided 1821 # this gracefully
1822 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1823 case ${missing_action} in
1824 true) return 0;;
1825 false) return 1;;
1607 [[ ! -e ${USEFILE} ]] && die "Unable to determine what USE flags $PKG was built with" 1826 die) die "Unable to determine what USE flags $PKG was built with";;
1827 esac
1828 fi
1608 1829
1830 if [[ ${hidden} == "no" ]] ; then
1609 local IUSE_BUILT=$(<${IUSEFILE}) 1831 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1610 # Don't check USE_EXPAND #147237 1832 # Don't check USE_EXPAND #147237
1611 local expand 1833 local expand
1612 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1834 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1613 if [[ $1 == ${expand}_* ]] ; then 1835 if [[ $1 == ${expand}_* ]] ; then
1614 expand="" 1836 expand=""
1615 break 1837 break
1616 fi 1838 fi
1617 done 1839 done
1618 if [[ -n ${expand} ]] ; then 1840 if [[ -n ${expand} ]] ; then
1841 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1842 case ${missing_action} in
1843 true) return 0;;
1844 false) return 1;;
1619 has $1 ${IUSE_BUILT} || die "$PKG does not actually support the $1 USE flag!" 1845 die) die "$PKG does not actually support the $1 USE flag!";;
1846 esac
1847 fi
1848 fi
1620 fi 1849 fi
1621 1850
1622 local USE_BUILT=$(<${USEFILE}) 1851 local USE_BUILT=$(<${USEFILE})
1623 while [[ $# -gt 0 ]] ; do 1852 while [[ $# -gt 0 ]] ; do
1624 if [[ ${opt} = "-o" ]] ; then 1853 if [[ ${opt} = "-o" ]] ; then
1629 shift 1858 shift
1630 done 1859 done
1631 [[ ${opt} = "-a" ]] 1860 [[ ${opt} = "-a" ]]
1632} 1861}
1633 1862
1863# @FUNCTION: epunt_cxx
1864# @USAGE: [dir to scan]
1865# @DESCRIPTION:
1634# Many configure scripts wrongly bail when a C++ compiler 1866# Many configure scripts wrongly bail when a C++ compiler could not be
1635# could not be detected. #73450 1867# detected. If dir is not specified, then it defaults to ${S}.
1868#
1869# http://bugs.gentoo.org/73450
1636epunt_cxx() { 1870epunt_cxx() {
1637 local dir=$1 1871 local dir=$1
1638 [[ -z ${dir} ]] && dir=${S} 1872 [[ -z ${dir} ]] && dir=${S}
1639 ebegin "Removing useless C++ checks" 1873 ebegin "Removing useless C++ checks"
1640 local f 1874 local f
1641 for f in $(find ${dir} -name configure) ; do 1875 find "${dir}" -name configure | while read f ; do
1642 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1876 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1643 done 1877 done
1644 eend 0 1878 eend 0
1645} 1879}
1646 1880
1647# dopamd <file> [more files] 1881# @FUNCTION: make_wrapper
1648# 1882# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1649# Install pam auth config file in /etc/pam.d 1883# @DESCRIPTION:
1650dopamd() { 1884# Create a shell wrapper script named wrapper in installpath
1651 [[ -z $1 ]] && die "dopamd requires at least one argument" 1885# (defaults to the bindir) to execute target (default of wrapper) by
1652 1886# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1653 use pam || return 0 1887# libpaths followed by optionally changing directory to chdir.
1654
1655 INSDESTTREE=/etc/pam.d \
1656 doins "$@" || die "failed to install $@"
1657}
1658# newpamd <old name> <new name>
1659#
1660# Install pam file <old name> as <new name> in /etc/pam.d
1661newpamd() {
1662 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1663
1664 use pam || return 0
1665
1666 INSDESTTREE=/etc/pam.d \
1667 newins "$1" "$2" || die "failed to install $1 as $2"
1668}
1669
1670# make a wrapper script ...
1671# NOTE: this was originally games_make_wrapper, but I noticed other places where
1672# this could be used, so I have moved it here and made it not games-specific
1673# -- wolf31o2
1674# $1 == wrapper name
1675# $2 == binary to run
1676# $3 == directory to chdir before running binary
1677# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1678# $5 == path for wrapper
1679make_wrapper() { 1888make_wrapper() {
1680 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1889 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1681 local tmpwrapper=$(emktemp) 1890 local tmpwrapper=$(emktemp)
1682 # We don't want to quote ${bin} so that people can pass complex 1891 # We don't want to quote ${bin} so that people can pass complex
1683 # things as $bin ... "./someprog --args" 1892 # things as $bin ... "./someprog --args"
1693fi 1902fi
1694exec ${bin} "\$@" 1903exec ${bin} "\$@"
1695EOF 1904EOF
1696 chmod go+rx "${tmpwrapper}" 1905 chmod go+rx "${tmpwrapper}"
1697 if [[ -n ${path} ]] ; then 1906 if [[ -n ${path} ]] ; then
1907 (
1698 exeinto "${path}" 1908 exeinto "${path}"
1699 newexe "${tmpwrapper}" "${wrapper}" 1909 newexe "${tmpwrapper}" "${wrapper}"
1910 ) || die
1700 else 1911 else
1701 newbin "${tmpwrapper}" "${wrapper}" 1912 newbin "${tmpwrapper}" "${wrapper}" || die
1913 fi
1914}
1915
1916# @FUNCTION: prepalldocs
1917# @USAGE:
1918# @DESCRIPTION:
1919# Compress files in /usr/share/doc which are not already
1920# compressed, excluding /usr/share/doc/${PF}/html.
1921# Uses the ecompressdir to do the compression.
1922# 2009-02-18 by betelgeuse:
1923# Commented because ecompressdir is even more internal to
1924# Portage than prepalldocs (it's not even mentioned in man 5
1925# ebuild). Please submit a better version for review to gentoo-dev
1926# if you want prepalldocs here.
1927#prepalldocs() {
1928# if [[ -n $1 ]] ; then
1929# ewarn "prepalldocs: invalid usage; takes no arguments"
1702 fi 1930# fi
1703} 1931
1932# cd "${D}"
1933# [[ -d usr/share/doc ]] || return 0
1934
1935# find usr/share/doc -exec gzip {} +
1936# ecompressdir --ignore /usr/share/doc/${PF}/html
1937# ecompressdir --queue /usr/share/doc
1938#}

Legend:
Removed from v.1.254  
changed lines
  Added in v.1.332

  ViewVC Help
Powered by ViewVC 1.1.20